/*
 * Khoros: $Id$
 */

/*
 * $Log$
 */

/*
 * Copyright (C) 1993, 1994, 1995, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Include file for KCMS private API
   >>>>
   >>>>    Written By: Neil Bowers
   >>>>
   >>>>          Date: Oct 30, 1992 14:54
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kcms_private_h_
#define _kcms_private_h_


	/*-------------------------------------*
	|       #include
	---------------------------------------*/

	/*-------------------------------------*
	|       #defines
	---------------------------------------*/

	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/

	/*-------------------------------------*
	|       macros
	---------------------------------------*/

	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/


/*----------------------------------------------------------------
|	Toolbox object private API: toolbox.c
\---------------------------------------------------------------*/

kobject	kcms_tb_create			PROTO((char *,char *));
kobject	kcms_tb_add			PROTO((char *,char *));
kobject	kcms_tb_open			PROTO((char *));
int	kcms_tb_close			PROTO((kobject));


/*----------------------------------------------------------------
|	CM object private API: cmobj.c
\---------------------------------------------------------------*/

kobject	kcms_cmobj_initialize		PROTO(( kobject, char *, char *));
kobject	kcms_cmobj_open			PROTO(( kobject, char *));
kobject	kcms_cmobj_complete_open	PROTO(( kobject));
int	kcms_cmobj_close		PROTO(( kobject));
kobject	kcms_cmobj_duplicate		PROTO(( kobject, kobject));
int	kcms_cmobj_destroy		PROTO(( kobject));


/*----------------------------------------------------------------
|	File object private API: file.c
\---------------------------------------------------------------*/

kobject	kcms_fobj_open			PROTO(( kobject,char *,char *,int,int,\
						int,int));
int	kcms_fobj_free			PROTO(( kobject));
kobject	kcms_fobj_duplicate		PROTO(( kobject,kobject));
int	kcms_fobj_destroy		PROTO(( kobject));
int	kcms_fobj_pack			PROTO(( kobject,char *));


/*----------------------------------------------------------------
|	Utility routines: utilities.c
\---------------------------------------------------------------*/

int kcms_gen_imakeandmake               PROTO((kobject, kstring));

kstring	kcms_query_template		PROTO(( kobject, int ));

kbool kcms_valid_object_path            PROTO((kstring));


#endif /* _kcms_private_h_ */
/* Don't add after this point */
